/*
 * sverb: an order 15 CFDN reverb
 * http://sed.free.fr/sverb
 * public domain
 * (there may be some patent for this stuff, I don't know and I don't care)
 * Cdric Roux <sed@free.fr>
 *
 * Algorithm comes from:
 * "Maximally Diffusive Yet Efficient Feedback Delay Networks for
 *  Artificial Reverberation", Davide Rocchesso, IEEE SIGNAL
 * PROCESSING LETTERS, VOL. 4, NO. 9, SEPTEMBER 1997
 * http://www.scienze.univr.it/documenti//ArticoloRivista/allegato/
 *   allegato128605.pdf
 * And:
 * "Circulant and elliptic feedback delay networks for artificial
 *  reverberation", D. Rocchesso and J. O. Smith, IEEE Trans. Speech
 * Audio Processing, vol. 5, pp. 51 63, Jan. 1997.
 * http://ccrma.stanford.edu/~jos/cfdn/cfdn.pdf
 * And:
 * http://ccrma.stanford.edu/~jos/Reverb/First_Order_Delay_Filter_Design.html
 * http://ccrma.stanford.edu/~jos/Reverb/Tonal_Correction_Filter.html
 * for the lowpass filters
 */

/*
 * let's do it by hand
 * it's quick and dirty hack
 * if you have better code, send it to me
 */

.text
.global _sverb_asm_process
.global _sverb_asm_process_no_t60

#the struct sverb (see sverb.h)
.equ DELAY, 0
.equ delays, 15*4*2
.equ cur, 15*4
.equ ld, 15*4*3
.equ tc, 15*4*3+15*12
.equ nb_bits, 15*4*3+15*12+12

#the arguments of the functions
.equ s, 144
.equ x, 148

_sverb_asm_process:
#int sverb_asm_process(sverb *s, long x)
        #esp = y
	#esp+4 = v[0]
        #esp+64 = ov[0]
	push	%ebp
	push	%esi
	push	%edi
	push	%ebx

	sub	$124, %esp
	mov	s(%esp), %ebp

	#get y
	mov	$15, %ecx
	xor	%ebx, %ebx
0:	#	mov	delays-4(,%ecx,4), %esi
	mov	delays-4(%ebp,%ecx,4), %esi
	#	mov	cur-4(,%ecx,4), %edx
	mov	cur-4(%ebp,%ecx,4), %edx
	addl	(%esi,%edx,4), %ebx
	loop	0b
	#tonal correction of y
	mov	tc(%ebp), %eax
	imull	tc+8(%ebp)
	mov	%eax, %ecx
mov %edx, %esi
	mov	tc+4(%ebp), %eax
	imul	%ebx
	sub	%ecx, %eax
sbb %esi, %edx
	mov	%ebx, tc+8(%ebp)
//	sar	$NB_BITS, %eax
mov	nb_bits(%ebp), %ecx
shrd %cl, %edx, %eax
	#store y
	mov	%eax, (%esp)

	#store ov
	mov	$15, %ecx
	leal	64+4*14(%esp), %edi
	#	movl	$lp+14*12, %esi
	leal	ld+14*12(%ebp), %esi
	std
0:	push	%ecx
	mov	delays-4(%ebp,%ecx,4), %ebx
	mov	cur-4(%ebp,%ecx,4), %edx
	movl	(%ebx,%edx,4), %eax
	#loss delay line
	imull	(%esi)
	mov	%eax, %ebx
mov %edx, %ecx
	mov	4(%esi), %eax
	imull	8(%esi)
	add	%ebx, %eax
adc %ecx, %edx
//	sar	$NB_BITS, %eax
mov nb_bits(%ebp), %cl
shrd %cl, %edx, %eax
	mov	%eax, 8(%esi)
	pop	%ecx
	#store ov
	stosl
	sub	$12, %esi
	loop	0b
	cld
	leal	4(%esp), %edi
#the diffusion matrix, hard-coded
#- + + + - + + - - + - + - - -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + + - + + - - + - + - - - -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + - + + - - + - + - - - - +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - + + - - + - + - - - - + +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + + - - + - + - - - - + + +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + - - + - + - - - - + + + -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - - + - + - - - - + + + - +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - + - + - - - - + + + - + +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + - + - - - - + + + - + + -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - + - - - - + + + - + + - -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + - - - - + + + - + + - - +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - - - - + + + - + + - - + -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - - - + + + - + + - - + - +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - - + + + - + + - - + - + -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - + + + - + + - - + - + - -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl

	#store new values
	mov	$15, %ecx
	//mov	$delay+4*4000*14, %edi
        leal	4+14*4(%esp), %esi
	std
0:	lodsl
	mov	delays-4(%ebp,%ecx,4), %edi
	mov	cur-4(%ebp,%ecx,4), %ebx
	movl	%eax, (%edi,%ebx,4)
	inc	%ebx
	cmp	DELAY-4(%ebp,%ecx,4), %ebx
	jb	1f
	xor	%ebx, %ebx
1:	mov	%ebx, cur-4(%ebp,%ecx,4)
	//sub	$4000*4, %edi
	loop	0b
	#return y
	mov	(%esp), %eax
	add	$124, %esp
	cld
	pop	%ebx
	pop	%edi
	pop	%esi
	pop	%ebp
	ret

_sverb_asm_process_no_t60:
#int sverb_asm_process_no_t60(sverb *s, long x)
        #esp = y
	#esp+4 = v[0]
        #esp+64 = ov[0]
	push	%ebp
	push	%esi
	push	%edi
	push	%ebx

	sub	$124, %esp
	mov	s(%esp), %ebp

	#get y
	mov	$15, %ecx
	xor	%eax, %eax
0:	mov	delays-4(%ebp,%ecx,4), %esi
	mov	cur-4(%ebp,%ecx,4), %edx
	addl	(%esi,%edx,4), %eax
	loop	0b
	mov	%eax, (%esp)

	#store ov
	mov	$15, %ecx
	leal	64+4*14(%esp), %edi
	leal	ld+14*12(%ebp), %esi
	std
0:	mov	delays-4(%ebp,%ecx,4), %ebx
	mov	cur-4(%ebp,%ecx,4), %edx
	movl	(%ebx,%edx,4), %eax
	mov	%eax, 8(%esi)
	#store ov
	stosl
	sub	$12, %esi
	loop	0b
	cld
	leal	4(%esp), %edi
#- + + + - + + - - + - + - - -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + + - + + - - + - + - - - -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + - + + - - + - + - - - - +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - + + - - + - + - - - - + +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + + - - + - + - - - - + + +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ + - - + - + - - - - + + + -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - - + - + - - - - + + + - +
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - + - + - - - - + + + - + +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + - + - - - - + + + - + + -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - + - - - - + + + - + + - -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- + - - - - + + + - + + - - +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	add	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#+ - - - - + + + - + + - - + -
	xor	%eax, %eax
	add	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	sub	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	add	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - - - + + + - + + - - + - +
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	sub	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	add	64+24(%esp), %eax
	sub	64+28(%esp), %eax
	add	64+32(%esp), %eax
	add	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	add	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - - + + + - + + - - + - + -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	sub	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	add	64+20(%esp), %eax
	sub	64+24(%esp), %eax
	add	64+28(%esp), %eax
	add	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	sub	64+40(%esp), %eax
	add	64+44(%esp), %eax
	sub	64+48(%esp), %eax
	add	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl
#- - + + + - + + - - + - + - -
	xor	%eax, %eax
	sub	64+0(%esp), %eax
	sub	64+4(%esp), %eax
	add	64+8(%esp), %eax
	add	64+12(%esp), %eax
	add	64+16(%esp), %eax
	sub	64+20(%esp), %eax
	add	64+24(%esp), %eax
	add	64+28(%esp), %eax
	sub	64+32(%esp), %eax
	sub	64+36(%esp), %eax
	add	64+40(%esp), %eax
	sub	64+44(%esp), %eax
	add	64+48(%esp), %eax
	sub	64+52(%esp), %eax
	sub	64+56(%esp), %eax
	sar	$2, %eax
	add	x(%esp), %eax
	stosl

	#store new values
	mov	$15, %ecx
	//mov	$delay+4*4000*14, %edi
        leal	4+14*4(%esp), %esi
	std
0:	lodsl
	mov	delays-4(%ebp,%ecx,4), %edi
	mov	cur-4(%ebp,%ecx,4), %ebx
	movl	%eax, (%edi,%ebx,4)
	inc	%ebx
	cmp	DELAY-4(%ebp,%ecx,4), %ebx
	jb	1f
	xor	%ebx, %ebx
1:	mov	%ebx, cur-4(%ebp,%ecx,4)
	//sub	$4000*4, %edi
	loop	0b
	#return y
	mov	(%esp), %eax
	add	$124, %esp
	cld
	pop	%ebx
	pop	%edi
	pop	%esi
	pop	%ebp
	ret
